> ## Documentation Index
> Fetch the complete documentation index at: https://v0.x-docs.novu.co/llms.txt
> Use this file to discover all available pages before exploring further.

# List all events

> List all notification events (triggered events) for the current environment. 
    This API supports filtering by **channels**, **templates**, **emails**, **subscriberIds**, **transactionId**, **topicKey**, **severity**, **contextKeys**. 
    Checkout all available filters in the query section.
    This API returns event triggers, to list each channel notifications, check messages APIs.

<Warning>
  Enter your API key in the `Authorization` field like the example shown below:

  E.g `ApiKey 18d2e625f05d80e`
</Warning>

<RequestExample>
  ```kotlin Kotlin theme={null}
  import co.novu.Novu
  import co.novu.dto.request.NotificationRequest
  import co.novu.extensions.notifications

  fun main() {
      val novu = Novu(apiKey = "<NOVU_API_KEY>")
      val notificationRequest = NotificationRequest("<CHANNELS>", "<TEMPLATES>", "<EMAILS>", "<SEARCH>");
      val notifications = novu.notifications(notificationRequest)
      println(notifications)
  }
  ```

  ```bash cURL theme={null}
  curl --request GET \
  --url https://api.novu.co/v1/notifications \
  --header 'Authorization: ApiKey <NOVU_API_KEY>'
  ```

  ```python Python theme={null}
  from novu.api import NotificationApi

  url = "https://api.novu.co"
  api_key = "<NOVU_API_KEY>"

  notificationApi = NotificationApi(url, api_key)

  notifications = notificationApi.list()
  ```

  ```php PHP theme={null}
  use Novu\SDK\Novu;

  $novu = new Novu('<NOVU_API_KEY>');

  $notifications = $novu->getNotifications()->toArray();
  ```
</RequestExample>


## OpenAPI

````yaml get /v1/notifications
openapi: 3.0.0
info:
  title: Novu API
  description: >-
    Novu REST API. Please see https://docs.novu.co/api-reference for more
    details.
  version: '1.0'
  contact:
    name: Novu Support
    url: https://discord.gg/novu
    email: support@novu.co
  termsOfService: https://novu.co/terms
  license:
    name: MIT
    url: https://opensource.org/license/mit
servers:
  - url: https://api.novu.co
  - url: https://eu.api.novu.co
security: []
tags:
  - name: Events
    description: >-
      Events represent a change in state of a subscriber. They are used to
      trigger workflows, and enable you to send notifications to subscribers
      based on their actions.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Subscribers
    description: >-
      A subscriber in Novu represents someone who should receive a message. A
      subscriber’s profile information contains important attributes about the
      subscriber that will be used in messages (name, email). The subscriber
      object can contain other key-value pairs that can be used to further
      personalize your messages.
    externalDocs:
      url: https://docs.novu.co/subscribers/subscribers
  - name: Topics
    description: >-
      Topics are a way to group subscribers together so that they can be
      notified of events at once. A topic is identified by a custom key. This
      can be helpful for things like sending out marketing emails or notifying
      users of new features. Topics can also be used to send notifications to
      the subscribers who have been grouped together based on their interests,
      location, activities and much more.
    externalDocs:
      url: https://docs.novu.co/subscribers/topics
  - name: Notification
    description: >-
      A notification conveys information from source to recipient, triggered by
      a workflow acting as a message blueprint. Notifications can be individual
      or bundled as digest for user-friendliness.
    externalDocs:
      url: https://docs.novu.co/getting-started/introduction
  - name: Integrations
    description: >-
      With the help of the Integration Store, you can easily integrate your
      favorite delivery provider. During the runtime of the API, the
      Integrations Store is responsible for storing the configurations of all
      the providers.
    externalDocs:
      url: https://docs.novu.co/channels-and-providers/integration-store
  - name: Layouts
    description: >-
      Novu allows the creation of layouts - a specific HTML design or structure
      to wrap content of email notifications. Layouts can be manipulated and
      assigned to new or existing workflows within the Novu platform, allowing
      users to create, manage, and assign these layouts to workflows, so they
      can be reused to structure the appearance of notifications sent through
      the platform.
    externalDocs:
      url: https://docs.novu.co/content-creation-design/layouts
  - name: Workflows
    description: >-
      All notifications are sent via a workflow. Each workflow acts as a
      container for the logic and blueprint that are associated with a type of
      notification in your system.
    externalDocs:
      url: https://docs.novu.co/workflows
  - name: Notification Templates
    description: >-
      Deprecated. Use Workflows (/workflows) instead, which provide the same
      functionality under a new name.
  - name: Workflow groups
    description: Workflow groups are used to organize workflows into logical groups.
  - name: Changes
    description: >-
      Changes represent a change in state of an environment. They are analagous
      to a pending pull request in git, enabling you to test changes before they
      are applied to your environment and atomically apply them when you are
      ready.
    externalDocs:
      url: >-
        https://docs.novu.co/platform/environments#promoting-pending-changes-to-production
  - name: Environments
    description: >-
      Novu uses the concept of environments to ensure logical separation of your
      data and configuration. This means that subscribers, and preferences
      created in one environment are never accessible to another.
    externalDocs:
      url: https://docs.novu.co/platform/environments
  - name: Inbound Parse
    description: >-
      Inbound Webhook is a feature that allows processing of incoming emails for
      a domain or subdomain. The feature parses the contents of the email and
      POSTs the information to a specified URL in a multipart/form-data format.
    externalDocs:
      url: https://docs.novu.co/platform/inbound-parse-webhook
  - name: Feeds
    description: >-
      Novu provides a notification activity feed that monitors every outgoing
      message associated with its relevant metadata. This can be used to monitor
      activity and discover potential issues with a specific provider or a
      channel type.
    externalDocs:
      url: https://docs.novu.co/activity-feed
  - name: Tenants
    description: >-
      A tenant represents a group of users. As a developer, when your apps have
      organizations, they are referred to as tenants. Tenants in Novu provides
      the ability to tailor specific notification experiences to users of
      different groups or organizations.
    externalDocs:
      url: https://docs.novu.co/tenants
  - name: Messages
    description: >-
      A message in Novu represents a notification delivered to a recipient on a
      particular channel. Messages contain information about the request that
      triggered its delivery, a view of the data sent to the recipient, and a
      timeline of its lifecycle events. Learn more about messages.
    externalDocs:
      url: https://docs.novu.co/workflows/messages
  - name: Organizations
    description: >-
      An organization serves as a separate entity within your Novu account. Each
      organization you create has its own separate integration store, workflows,
      subscribers, and API keys. This separation of resources allows you to
      manage multi-tenant environments and separate domains within a single
      account.
    externalDocs:
      url: https://docs.novu.co/platform/organizations
  - name: Execution Details
    description: >-
      Execution details are used to track the execution of a workflow. They
      provided detailed information on the execution of a workflow, including
      the status of each step, the input and output of each step, and the
      overall status of the execution.
    externalDocs:
      url: https://docs.novu.co/activity-feed
externalDocs:
  description: Novu Documentation
  url: https://docs.novu.co
paths:
  /v1/notifications:
    get:
      tags:
        - Notifications
      summary: Get notifications
      operationId: NotificationsController_listNotifications
      parameters:
        - name: channels
          required: true
          in: query
          schema:
            type: array
            items:
              type: string
              enum:
                - in_app
                - email
                - sms
                - chat
                - push
        - name: templates
          required: true
          in: query
          schema:
            type: array
            items:
              type: string
        - name: emails
          required: true
          in: query
          schema:
            type: array
            items:
              type: string
        - name: search
          required: true
          in: query
          deprecated: true
          schema:
            type: string
        - name: subscriberIds
          required: true
          in: query
          schema:
            type: array
            items:
              type: string
        - name: page
          required: false
          in: query
          schema:
            default: 0
            type: number
        - name: transactionId
          required: false
          in: query
          schema:
            type: string
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ActivitiesResponseDto'
        '409':
          description: >-
            The request could not be completed due to a conflict with the
            current state of the target resource.
          content:
            application/json:
              schema:
                type: string
                example: >-
                  Request with key 3909d656-d4fe-4e80-ba86-90d3861afcd7 is
                  currently being processed. Please retry after 1 second
        '429':
          description: 'The client has sent too many requests in a given amount of time. '
          content:
            application/json:
              schema:
                type: string
                example: API rate limit exceeded
        '503':
          description: >-
            The server is currently unable to handle the request due to a
            temporary overload or scheduled maintenance, which will likely be
            alleviated after some delay.
          content:
            application/json:
              schema:
                type: string
                example: Please wait some time, then try again.
      security:
        - api-key: []
      x-codeSamples:
        - lang: typescript
          label: NotificationsController_listNotifications
          source: |-
            import { Novu } from "@novu/api";
            import { Channels } from "@novu/api/models/operations";

            const novu = new Novu({
              apiKey: "<YOUR_API_KEY_HERE>",
            });

            async function run() {
              const result = await novu.notifications.list({
                channels: [
                  Channels.Chat,
                ],
                templates: [
                  "<value>",
                ],
                emails: [
                  "<value>",
                ],
                search: "<value>",
                subscriberIds: [
                  "<value>",
                ],
              });

              // Handle the result
              console.log(result)
            }

            run();
components:
  schemas:
    ActivitiesResponseDto:
      type: object
      properties:
        hasMore:
          type: boolean
        data:
          type: array
          items:
            $ref: '#/components/schemas/ActivityNotificationResponseDto'
        pageSize:
          type: number
        page:
          type: number
      required:
        - hasMore
        - data
        - pageSize
        - page
    ActivityNotificationResponseDto:
      type: object
      properties:
        _id:
          type: string
        _environmentId:
          type: string
        _organizationId:
          type: string
        transactionId:
          type: string
        createdAt:
          type: string
        channels:
          type: string
          items:
            type: string
            enum:
              - in_app
              - email
              - sms
              - chat
              - push
              - digest
              - trigger
              - delay
              - custom
          enum:
            - in_app
            - email
            - sms
            - chat
            - push
            - digest
            - trigger
            - delay
            - custom
        subscriber:
          $ref: '#/components/schemas/ActivityNotificationSubscriberResponseDto'
        template:
          $ref: '#/components/schemas/ActivityNotificationTemplateResponseDto'
        jobs:
          type: array
          items:
            $ref: '#/components/schemas/ActivityNotificationJobResponseDto'
      required:
        - _environmentId
        - _organizationId
        - transactionId
    ActivityNotificationSubscriberResponseDto:
      type: object
      properties:
        firstName:
          type: string
        _id:
          type: string
        lastName:
          type: string
        email:
          type: string
        phone:
          type: string
      required:
        - _id
    ActivityNotificationTemplateResponseDto:
      type: object
      properties:
        _id:
          type: string
        name:
          type: string
        triggers:
          type: array
          items:
            $ref: '#/components/schemas/NotificationTrigger'
      required:
        - name
        - triggers
    ActivityNotificationJobResponseDto:
      type: object
      properties:
        _id:
          type: string
        type:
          type: string
        digest:
          type: object
        executionDetails:
          type: array
          items:
            $ref: >-
              #/components/schemas/ActivityNotificationExecutionDetailResponseDto
        step:
          $ref: '#/components/schemas/ActivityNotificationStepResponseDto'
        payload:
          type: object
        providerId:
          type: object
        status:
          type: string
      required:
        - _id
        - type
        - executionDetails
        - step
        - providerId
        - status
    NotificationTrigger:
      type: object
      properties:
        type:
          type: string
          enum:
            - event
        identifier:
          type: string
        variables:
          type: array
          items:
            $ref: '#/components/schemas/NotificationTriggerVariable'
        subscriberVariables:
          type: array
          items:
            $ref: '#/components/schemas/NotificationTriggerVariable'
      required:
        - type
        - identifier
        - variables
    ActivityNotificationExecutionDetailResponseDto:
      type: object
      properties:
        _id:
          type: string
        _jobId:
          type: string
        status:
          type: string
          enum:
            - Success
            - Warning
            - Failed
            - Pending
            - Queued
            - ReadConfirmation
        detail:
          type: string
        isRetry:
          type: boolean
        isTest:
          type: boolean
        providerId:
          type: object
        raw:
          type: string
        source:
          type: string
          enum:
            - Credentials
            - Internal
            - Payload
            - Webhook
      required:
        - _id
        - _jobId
        - status
        - detail
        - isRetry
        - isTest
        - providerId
        - source
    ActivityNotificationStepResponseDto:
      type: object
      properties:
        _id:
          type: string
        active:
          type: boolean
        filters:
          $ref: '#/components/schemas/StepFilter'
        template:
          $ref: '#/components/schemas/MessageTemplateDto'
      required:
        - _id
        - active
        - filters
    NotificationTriggerVariable:
      type: object
      properties:
        name:
          type: string
      required:
        - name
    StepFilter:
      type: object
      properties:
        isNegated:
          type: boolean
        type:
          type: string
          enum:
            - BOOLEAN
            - TEXT
            - DATE
            - NUMBER
            - STATEMENT
            - LIST
            - MULTI_LIST
            - GROUP
        value:
          type: string
          enum:
            - AND
            - OR
        children:
          type: array
          items:
            $ref: '#/components/schemas/FieldFilterPart'
      required:
        - isNegated
        - type
        - value
        - children
    MessageTemplateDto:
      type: object
      properties: {}
    FieldFilterPart:
      type: object
      properties:
        field:
          type: string
        value:
          type: string
        operator:
          type: string
          enum:
            - LARGER
            - SMALLER
            - LARGER_EQUAL
            - SMALLER_EQUAL
            - EQUAL
            - NOT_EQUAL
            - ALL_IN
            - ANY_IN
            - NOT_IN
            - BETWEEN
            - NOT_BETWEEN
            - LIKE
            - NOT_LIKE
            - IN
        'on':
          type: string
          enum:
            - subscriber
            - payload
      required:
        - field
        - value
        - operator
        - 'on'
  securitySchemes:
    api-key:
      type: apiKey
      in: header
      name: Authorization
      description: >-
        API key authentication. Allowed headers-- "Authorization: ApiKey
        <api_key>".

````